#include "requesthandler.h"
#include <Tufao/HttpServerRequest>
#include <Tufao/Headers>

RequestHandler::RequestHandler(QObject *parent) :
    Tufao::AbstractHttpServerRequestHandler(parent)
{
}

bool RequestHandler::handleRequest(Tufao::HttpServerRequest *request,
                                   Tufao::HttpServerResponse *response,
                                   const QStringList &args)
{
    Q_UNUSED(request)
    Q_UNUSED(args)

    response->writeHead(Tufao::HttpServerResponse::MOVED_PERMANENTLY);
    // O padrão proibe o uso de URLs relativas no cabeçalho Location,
    // mas como a maioria dos navegadores aceita esse recurso
    // e por questões de praticidade, o mesmo é utilizado aqui.
    // Entretanto, desencorajo seu uso em projetos reais.
    response->headers().insert("Location", "/index.html");
    response->end();
    return true;
}
