#include "webserver.h"
#include "websocketchat.h"

#include <Tufao/HttpServerRequest>

WebServer::WebServer(QObject *parent) :
    Tufao::HttpServer(parent)
{
}

void WebServer::upgrade(Tufao::HttpServerRequest *request,
                        const QByteArray &head)
{
    // Assim como requisições comuns, conexões do tipo WebSocket também podem
    // servir vários recursos diferentes
    if (request->url() != "/chat") {
        Tufao::HttpServerResponse response(request->socket(),
                                           request->responseOptions());
        response.writeHead(Tufao::HttpServerResponse::NOT_FOUND);
        response.end("Not found");
        request->socket()->close();
        return;
    }

    Tufao::WebSocket *socket = new WebSocketChat(this);
    if (!socket->startServerHandshake(request, head)) {
        socket->deleteLater();
        return;
    }
    socket->setMessagesType(Tufao::WebSocket::TEXT_MESSAGE);

    connect(socket, SIGNAL(disconnected()), socket, SLOT(deleteLater()));
}
